# -*- coding: utf-8 -*-
"""
Programa para comparar la formulaciones para un péndulo simple
con pequeñas y grandes amplitudes

@author: TO_DO
@date:   TO_DO
"""

#TO_DO: añadir los import adicionales que se necesiten

from typing import List
from typing import Tuple

import numpy as np
import matplotlib.pyplot as plt

# Constantes

# TO_DO: Escribir las constantes del módulo

# TO_DO: Escribir la función phi_simple()


def avanza_simulacion(intervalo: float, phi_actual: float,
                      w_actual: float)-> Tuple[float, float]:
    """
    TO_DO: Escribir la función con su comentario de documentación
    """


def simula():
    """
    Realiza la simulación mostrando gráficas de los resultados

    Permite comparar gráficamente los resultados de pequeñas amplitudes
    con los de grandes amplitudes
    """

    # Intervalo de la simulación (s)
    intervalo: float = 0.0005

    # Creamos tres listas para el tiempo, la posición con pequeñas amplitudes,
    # y la posición con grandes amplitudes
    list_t: List[float] = np.linspace(0.0, 10.0, int(10.0/intervalo))
    list_pa: List[float] = []
    list_ga: List[float] = []

    # Inicializamos la posición y velocidad del péndulo para la simulación
    # con grandes amplitudes
    phi_ga: float = PHI_MAX
    w_ga: float = 0

    # Recorremos la lista del tiempo y añadimos a las listas las
    # posiciones angulares
    for tiempo in list_t:
        list_pa.append(phi_simple(tiempo))
        list_ga.append(phi_ga)
        # Avanzamos la simulación
        phi_ga, w_ga = avanza_simulacion(intervalo, phi_ga, w_ga)

    # Creamos la grafica para dibujar la trayectoria con pequeñas amplitudes
    plt.plot(list_t, list_pa, 'r', label="pequeñas amplitudes")
    # Creamos la grafica para dibujar la trayectoria con grandes amplitudes
    plt.plot(list_t, list_ga, 'b', label="grandes amplitudes")

    # Decoraciones
    plt.ylabel('Angulo (rad)')
    plt.xlabel('Tiempo(s)')
    plt.title('Trayectoria de un péndulo')
    plt.grid(True)
    plt.legend()

    # Mostrar las gráficas
    plt.show()
